{% extends "ajax/ajax_plain.html.twig" %}
{% block ajax_base %}
    <div class="row">
        <div class="cell rw-12">
            <div class="forum-note">
                <b>{{ 'Nachrichten suchen'|trans({},'global') }}</b>

                <div class="row-flex v-center">
                    <div class="cell padded rw-3 small">
                        <label for="search-query">{{'Suchbegriff'|trans({}, 'global')}}</label>
                    </div>
                    <div class="cell padded rw-9">
                        <input type="text" id="search-query" name="search-query" placeholder="{{'Suchbegriffe eingeben'|trans({}, 'global')}}" {% if query %}value="{{ query }}"{% endif%} >
                    </div>
                </div>

                <div class="row-flex v-center">
                    <div class="cell padded rw-3 small">
                        <label for="search-query">{{'Benutzer (optional)'|trans({}, 'global')}}</label>
                    </div>
                    <div class="cell padded rw-9">
                        <div id="search_selected_user" style="display: none;">
                            <span class="bold" style="font-size: 1.5rem"></span>
                            <div class="float-right">
                                <img class="pointer" alt="" src="{{ asset('build/images/icons/b_close.png') }}">
                                <div class="tooltip">{{ 'Entfernen'|trans({},'global') }}</div>
                            </div>
                        </div>
                        <hordes-user-search id="users-search"
                                data-alias="{{ alias == select ? 1 : 0 }}" data-context="forum-search"
                                data-self="1" data-title="{{ 'Gib den Pseudo des Bürgers ein.'|trans({},'soul') }}"
                        ></hordes-user-search>
                    </div>
                </div>

                <div class="row-flex v-center">
                    <div class="cell padded rw-3 small">
                        <label for="search-forum">{{'Forum'|trans({}, 'global')}}</label>
                    </div>
                    <div class="cell padded rw-9">
                        <select name="search-forum" id="search-forum">
                            <option value="-1">- {{ 'Alle Foren'|trans({}, 'global') }} -</option>
                            {% for section in forumSections %}
                                <optgroup label="{{ 'Weltforum'|trans({},'global',section) }}">
                                    {% for forum in forums|filter( f => f.worldForumLanguage == section )|sort( (a,b) => ( a.worldForumSorting <=> b.worldForumSorting ) ) %}
                                        <option value="{{ forum.id }}" {% if forum.id == select %}selected{% endif %}>{{ forum.title }}</option>
                                    {% endfor %}
                                </optgroup>
                            {% endfor %}
                            {% for forum in forums|filter( f => f.worldForumLanguage is null )|sort( (a,b) => ( a.title <=> b.title ) ) %}
                                {# @var forum \App\Entity\Forum #}
                                <option value="{{ forum.id }}" {% if forum.id == select %}selected{% endif %}>{{ forum.title }}</option>
                            {% endfor %}
                        </select>
                    </div>
                </div>

                <div class="row-flex v-center">
                    <div class="cell padded rw-3 small">
                        <label>{{'Optionen'|trans({}, 'global')}}</label>
                    </div>
                    <div class="cell padded rw-9">
                        <label><input {% if titles %}checked{% endif %} type="checkbox" id="search-opt-title" name="search-opt-title">{{'In Titeln suchen'|trans({}, 'global')}}</label>
                    </div>
                </div>

                <div class="row-flex">
                    <div class="cell padded rw-3 small">
                        <label>{{'Tipps zur Suche'|trans({}, 'global')}}</label>
                    </div>
                    <div class="cell padded rw-9">
                        <ul style="padding-left: 10px; margin: 0;">
                            <li>{{ 'Benutze Anführungszeichen (" "), um nach einer bestimmten Wortkette zu suchen. Beispiel: "Ration Wasser"'|trans({}, 'global') }}</li>
                            <li>{{ 'Setze ein Ausrufezeichen (!) vor einen Suchbegriff, um diesen auszuschließen. Beispiel: Wasser !Brunnen'|trans({}, 'global')|raw }}</li>
                            <li>{{ 'Um nach Anführungszeichen oder Ausrufezeichen zu suchen, schreibe einen Backslash (\\) davor, um zu verhindern, dass sie als Suchbefehl interpretiert werden. Beispiel: Boom\\!'|trans({}, 'global') }}</li>
                        </ul>
                    </div>
                </div>

                <br />

                <div class="row">
                    <div class="padded cell rw-4"><button id="search-begin-btn">{{ 'Suchen'|trans({}, 'global') }}</button></div>
                </div>
            </div>
            <br />
            <div id="search-results"></div>
        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    {{ include('ajax/flash.html.twig') }}
    <script>
        const doSearch = () => {
            const obj = {
                fid: parseInt(document.querySelector('#search-forum').value),
                query: document.querySelector('#search-query').value,
                opt_title: document.querySelector('#search-opt-title').checked ? 1 : 0,
                user: document.querySelector('[x-selected-user]') ? parseInt(document.querySelector('[x-selected-user]').getAttribute('x-selected-user')) : -1
            }

            const url = '{{ path('forum_search_wrapper_controller') }}?f=' + obj.fid + '&ot=' + obj.opt_title + '&u=' + obj.user + '&q=' + encodeURIComponent(obj.query);
            if (url !== history.state) history.pushState( url, '', url );
            $.ajax.no_history().load(document.getElementById('search-results'), '{{ path('forum_query_controller')|e('js') }}', false, obj)
        };

        document.getElementById('search-forum')?.addEventListener('change', e =>
            document.getElementById('users-search').dataset.alias = parseInt(e.target.value) === {{ alias }} ? '1' : '0'
        );

        $.html.addEventListenerAll('#search-query', 'keydown', e => e.key === 'Enter' && doSearch());

        $.html.addEventListenerAll('#search-begin-btn', 'click', doSearch);

        $.html.addEventListenerAll('#search_selected_user img', 'click', () => {
            let e = document.getElementById('search_selected_user');
            e.style.display = 'none';
            e.removeAttribute('x-selected-user');

            let s = document.getElementById('users-search');
            s.style.display = null;

            searchBox.value = '';
        })

        document.getElementById('users-search')?.addEventListener('hordes-user-search-callback', e => {
            let es = document.getElementById('search_selected_user');
            es.style.display = null;
            es.setAttribute('x-selected-user', e.detail[0].id);
            es.querySelector('span').innerText = e.detail[0].name;

            let ss = document.getElementById('users-search');
            ss.style.display = 'none';
        });

        {% if user %}
            let es = document.getElementById('search_selected_user');
            es.style.display = null;
            es.setAttribute('x-selected-user', {{ user.id }});
            es.querySelector('span').innerText = '{{ user.name|e('js') }}';

            let ss = document.getElementById('users-search');
            ss.style.display = 'none';
        {% endif %}

        {% if user or query %}
            doSearch();
        {% endif %}
    </script>
{% endblock %}
